#include <stdio.h>
#include "mex.h"
#include "matrix.h"

 void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {

 /* define variables */
 double *data;
 char *file_name;
 size_t len;
 
 
/* check inputs */

 if (!(nrhs == 2)) {
 mexErrMsgTxt("Wrong nbr of inputs");
} 
 
  
 data = mxGetPr(prhs[0]);
len = mxGetM(prhs[0]);

 file_name = mxArrayToString(prhs[1]);

 FILE *fp = fopen(file_name, "wb");
 if (!fp){
     mexErrMsgTxt("File could not open");
 }

/* Write data to the file */
size_t fw = fwrite(data, sizeof(double), len, fp);
if (fw != len){
    mexErrMsgTxt("Could not write to file");
 }


/* close file stream */
fclose(fp);

 
/* free input string */
mxFree(file_name);
}
