function exit_message(QP,opts)


fprintf('-----------------------------------------------------------\n');
fprintf(['C code generated with options (in opts struct):\n\n']);
disp(opts)
fprintf('Change any of these option using the function change_opts()\n');
fprintf('-----------------------------------------------------------\n');
input_str = [];
if QP.gt == 1
    input_str = [input_str 'gt'];
end
if QP.bt == 1
    if not(isempty(input_str))
        input_str = [input_str ','];
    end
    input_str = [input_str 'bt'];
end
input_str_c = [];
if opts.stack_usage < 2
    input_str_c = [input_str_c 'd,'];
    if opts.stack_usage == 0
        input_str_c = [input_str_c 'ws'];
    end
end

fprintf('Generated files: QPgen.h (header file)\n');
fprintf('%17sQPgen.c (main C file with solver qp())\n','');
fprintf('%17sqp_mex.c (mex gateway-file)\n','');
if opts.stack_usage < 2
    fprintf('%17sinit_data.c (initilize problem data)\n','');
    fprintf('%17sfree_data.c (free problem data)\n','');
    fprintf('%17sdata_struct.h (declaration of struct DATA)\n','');
end
if opts.stack_usage == 0
    fprintf('%17sinit_work_space.c (initilize work space)\n','');
    fprintf('%17sfree_work_space.c (free work space)\n','');
    fprintf('%17swork_space_struct.h (declaration of struct WORK_SPACE)\n','');
end
fprintf('%17sqp_mex.mex* (compiled mex-file)\n','');
if opts.stack_usage < 2
   fprintf('%17s*.bin (data files)\n','');
end
fprintf('-----------------------------------------------------------\n');
fprintf(['Usage MATLAB: [sol,iter] = qp_mex(' input_str ');\n']);
fprintf('-----------------------------------------------------------\n');
fprintf('Usage C:\n');
if opts.stack_usage == 2
    fprintf([' - compile QPgen.c\n']);
elseif opts.stack_usage == 1
    fprintf([' - compile QPgen.c init_data.c free_data.c\n']);
elseif opts.stack_usage == 0
    fprintf([' - compile QPgen.c init_data.c free_data.c init_work_space.c free_work_space.c\n']);
end
input_str1 = [];
if QP.gt == 1
    input_str1 = [input_str1 opts.precision ' *gt'];
end
if QP.bt == 1
    if not(isempty(input_str1))
        input_str1 = [input_str1 ','];
    end
    input_str1 = [input_str1 opts.precision ' *bt'];
end
input_str_c1 = [];
if opts.stack_usage < 2
    input_str_c1 = [input_str_c1 'struct DATA *d,'];
    if opts.stack_usage == 0
        input_str_c1 = [input_str_c1 'struct WORK_SPACE *ws,'];
    end
end
if opts.stack_usage < 2
    fprintf([' - initialize data (ones before solving problems, input to qp()):\n       void init_data(struct DATA *d);\n']);
    fprintf([' - free data (ones after solving problems):\n       void free_data(struct DATA *d);\n']);
end
if opts.stack_usage == 0
    fprintf([' - initialize work_space (ones before solving problems, input to qp()):\n       void init_work_space(struct WORK_SPACE *ws);\n']);
    fprintf([' - free work_space (ones after solving problems):\n       void free_work_space(struct WORK_SPACE *ws);\n']);
end
fprintf([' - solve using function qp(' input_str_c 'sol,iter,' input_str '):\n       void qp(' input_str_c1 opts.precision ' *sol, int *iter, ' input_str1 ');\n']);
input_size = [];
if QP.gt == 1
    input_size = [input_size 'size(gt) = ' int2str(size(QP.G,2)) 'x1'];
end
if QP.bt == 1
    if not(isempty(input_size))
        input_size = [input_size ', '];
    end
    input_size = [input_size 'size(bt) = ' int2str(size(QP.B,2)) 'x1'];
end
fprintf('-----------------------------------------------------------\n');
fprintf(['Input dimensions: ' input_size '\n']);
fprintf('-----------------------------------------------------------\n');
fprintf(['Output dimensions: size(sol) = ' int2str(length(QP.H)) 'x1, size(iter) = 1x1\n']);
fprintf('-----------------------------------------------------------\n');